com.icl.saxon.expr

## Class EmptyNodeSet

- java.lang.Object
- - com.icl.saxon.expr.Expression
  - - com.icl.saxon.expr.Value
    - - com.icl.saxon.expr.NodeSetValue
      - - com.icl.saxon.expr.EmptyNodeSet

-     public final class EmptyNodeSet
      extends NodeSetValue

  A node-set value no nodes

- - ### Field Summary

    - ### Fields inherited from class com.icl.saxon.expr.Value

      `ANY, BOOLEAN, NODESET, NUMBER, OBJECT, STRING`

    - ### Fields inherited from class com.icl.saxon.expr.Expression

      `staticContext`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `EmptyNodeSet()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `asBoolean()` Evaluate as a boolean.
    `java.lang.String` | `asString()` Convert to string value
    `NodeEnumeration` | `enumerate()` Return an enumeration of this nodeset value.
    `boolean` | `equals(Value other)` Test whether this nodeset "equals" another Value
    `Value` | `evaluate(Context context)` Evaluate the Node Set.
    `NodeSetValue` | `evaluateAsNodeSet(Context context)` Evaluate an expression as a NodeSet.
    `int` | `getCount()` Count the nodes in the node-set.
    `NodeInfo` | `getFirst()` Get the first node in the nodeset (in document order)
    `boolean` | `isContextDocumentNodeSet()` Determine, in the case of an expression whose data type is Value.NODESET, whether all the nodes in the node-set are guaranteed to come from the same document as the context node.
    `boolean` | `isSorted()` Test whether the value is known to be sorted
    `boolean` | `notEquals(Value other)` Test whether this nodeset "not-equals" another Value
    `void` | `setSorted(boolean isSorted)` Set a flag to indicate whether the nodes are sorted.
    `NodeSetValue` | `sort()` Sort the nodes into document order.

    - ### Methods inherited from class com.icl.saxon.expr.NodeSetValue

      `asNumber, compare, conversionPreference, convertToJava, display, enumerate, getDataType`

    - ### Methods inherited from class com.icl.saxon.expr.Value

      `getDependencies, inverse, numericCompare, reduce, simplify, stringToNumber`

    - ### Methods inherited from class com.icl.saxon.expr.Expression

      `containsReferences, evaluateAsBoolean, evaluateAsNumber, evaluateAsString, getStaticContext, indent, make, outputStringValue, setStaticContext, usesCurrent`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### EmptyNodeSet

          public EmptyNodeSet()

  - ### Method Detail

    - #### evaluate

          public Value evaluate(Context context)

      Evaluate the Node Set. This guarantees to return the result in sorted order.
      Overrides:
        `evaluate` in class `NodeSetValue`
      Parameters:
        `context` - The context for evaluation (not used)
      Returns:
        the value, unchanged

    - #### evaluateAsNodeSet

          public NodeSetValue evaluateAsNodeSet(Context context)

      Evaluate an expression as a NodeSet.
      Overrides:
        `evaluateAsNodeSet` in class `NodeSetValue`
      Parameters:
        `context` - The context in which the expression is to be evaluated
      Returns:
        the value of the expression, evaluated in the current context

    - #### setSorted

          public void setSorted(boolean isSorted)

      Set a flag to indicate whether the nodes are sorted. Used when the creator of the node-set knows that they are already in document order.
      Specified by:
        `setSorted` in class `NodeSetValue`
      Parameters:
        `isSorted` - true if the caller wishes to assert that the nodes are in document order and do not need to be further sorted

    - #### isSorted

          public boolean isSorted()

      Test whether the value is known to be sorted
      Specified by:
        `isSorted` in class `NodeSetValue`
      Returns:
        true if the value is known to be sorted in document order, false if it is not known whether it is sorted.

    - #### isContextDocumentNodeSet

          public boolean isContextDocumentNodeSet()

      Determine, in the case of an expression whose data type is Value.NODESET, whether all the nodes in the node-set are guaranteed to come from the same document as the context node. Used for optimization.
      Overrides:
        `isContextDocumentNodeSet` in class `Expression`

    - #### asString

          public java.lang.String asString()

      Convert to string value
      Specified by:
        `asString` in class `NodeSetValue`
      Returns:
        an empty string

    - #### asBoolean

          public boolean asBoolean()

      Evaluate as a boolean.
      Specified by:
        `asBoolean` in class `NodeSetValue`
      Returns:
        false

    - #### getCount

          public int getCount()

      Count the nodes in the node-set.
      Specified by:
        `getCount` in class `NodeSetValue`
      Returns:
        zero

    - #### sort

          public NodeSetValue sort()

      Sort the nodes into document order. This does nothing if the nodes are already known to be sorted; to force a sort, call setSorted(false)
      Specified by:
        `sort` in class `NodeSetValue`
      Returns:
        the same NodeSetValue, after sorting. (Historic)

    - #### getFirst

          public NodeInfo getFirst()

      Get the first node in the nodeset (in document order)
      Specified by:
        `getFirst` in class `NodeSetValue`
      Returns:
        null

    - #### equals

          public boolean equals(Value other)

      Test whether this nodeset "equals" another Value
      Overrides:
        `equals` in class `NodeSetValue`
      Returns:
        a boolean giving the value of the expression, evaluated in the current context

    - #### notEquals

          public boolean notEquals(Value other)

      Test whether this nodeset "not-equals" another Value
      Overrides:
        `notEquals` in class `NodeSetValue`
      Returns:
        a boolean giving the value of the expression, evaluated in the current context

    - #### enumerate

          public NodeEnumeration enumerate()

      Return an enumeration of this nodeset value.
      Specified by:
        `enumerate` in class `NodeSetValue`